# Allgemeines

Zuerst geht es darum, zu verdeutlichen, was genau die Aufgabe war und wie diese realisierbar wurde.  
Der erste Schritt war, das Grundprinzip hinter einer Node und einem Topic zu verstehen.


Emphasis using *Italics*, **bold**.
The paragraph continues

This is the second paragraph.

## Node

Eine Node-basierte Software, beispielsweise die, die den Wafflebot fahren lässt, wird in verschiedene Einzelteile
aufgeteilt. Hierfür wird jeder vergebenen Aufgabe genau eine Node zugeordnet. Somit sind Nodes im Prinzip die Bauteile
eines ROS-Skriptes. Eine Beispielaufgabe hierfür wäre das Auslesen der Sensordaten des Lasers, der sich auf dem
Wafflebot befindet. Um nun fahren zu können, muss der Roboter die Motoren der einzelnen Reifen ansteuern. Auch das sind
Aufgaben, die je eine Node übernehmen kann. Beispiel für das Erstellen einer neuen Node anhand der im Git enthaltenen
Turtlebot3 Node:

```python
import rclpy  # ROS client library
from rclpy.node import Node

class Tb3(Node):
    def __init__(self):
        super().__init__('tb3')
    
    def main(args=None):
        rclpy.init(args=args)
        tb3 = Tb3()
        try:
            rclpy.spin(tb3)  # Führt die tb3 Node aus
            # Blockiert solange, bis die rclpy.spin(tb3) Methode nicht mehr ausgeführt wird
        except KeyboardInterrupt:
            pass
        
        tb3.destroy_node()
        rclpy.shutdown()
``` 

Kurzer Breakdown der einzelnen Steps beim Erstellen einer Node:

```
Test
```

Kermit from the Muppet Movie:

> Life's like a movie. Write your own ending.

## Lists

- apple
- banana
- cherry

## Links

More info can be found on [Python docs – Exceptions](https://docs.python.org/3/reference/executionmodel.html#exceptions).

## Images

![Charles J. Sharp, CC BY-SA 4.0 <https://creativecommons.org/licenses/by-sa/4.0>, via Wikimedia Commons](https://upload.wikimedia.org/wikipedia/commons/thumb/8/81/Scarlet_darter_%28Crocothemis_erythraea%29_female_Bulgaria.jpg/320px-Scarlet_darter_%28Crocothemis_erythraea%29_female_Bulgaria.jpg)

## Code snippets

We can use `find -iname STRING` to search for a file in Unix.

The following code[^1] shuffles a list:

```python
from random import shuffle

foo = [1, 2, 3, 4]
shuffle(foo) 
print(foo)
```

## The end

If you want to try these, follow this [Markdown tutorial](https://commonmark.org/help/tutorial). It also includes a web-based code editor.

[^1]: Code from [PythonSnippets.dev](https://pythonsnippets.dev/snippet/23/)
